// 1. 浏览器类型默认分为两种进行处理，一种是与安卓内置浏览器兼容的浏览器，统称为系统浏览器；
// 一种Chrome浏览器。
// 2. 进行这种区分的依据是，系统浏览器与Chrome浏览器在启动安卓自带的app时的机制不一样。
// 系统浏览器使用的是创建iframe节点，然后给iframe的src设置自定义协议的url；而Chrome
// 浏览器在25以后不再支持这种办法，只能使用intent协议的url
var SysBrowser = "SysBrowser";
var ChromeBrowser = "ChromeBrowser";
var UnknownBrowser = "UnknownBrowser";

// 既不是系统浏览器也不是Chrome的浏览器都称之为未知浏览器
var g_browser_type = UnknownBrowser;
function getBrowserType() {
	return g_browser_type;
}

function setBrowserType(type) {
	g_browser_type = type;	
}

 // 检测浏览器的类型
function checkBrowserType() {
	var ua = window.navigator.userAgent;
	var browserType = "";

	// 系统内置浏览器、傲游浏览器、QQ浏览器、UC浏览器、
	// 360浏览器和百度浏览器都包含这个字段
	if (ua.indexOf("Version") >= 0) {
		// 1. Android 2.3上的WebView不支持使用iframe
		// 打开自定义协议的app，支持使用window.location.href
		// 打开自定义协议的app，因此这里将浏览器类型看成
		// Chrome手机浏览器，从而使用window.location.href
		// 来打开相应的app
		// 2. 将来这个地方可能视情况需要优化，改为不再
		// 判断浏览器类型，而是综合考虑操作系统和浏览器两方面
		// 因素从而决定使用哪种方式打开自定义协议的app
		if (ua.indexOf("Android 2.3") >= 0) {
			browserType = ChromeBrowser;
		} else {			
			browserType = SysBrowser;
		}
	} else if (ua.indexOf("Chrome") >= 0) {
		browserType = ChromeBrowser;
	} else {
		browserType = UnknownBrowser;
		alert("该浏览器尚未被支持，请使用傲游浏览器！");
	}

	setBrowserType(browserType);
}

checkBrowserType();

var HuaweiPlatform = "HuaweiPlatform";
var XiaomiPlatform = "MIUIPlatform";
var NexusPlatform = "NexusPlatform";
var UnknownPlatform = "UnknownPlatform";

var g_system_platform = UnknownPlatform;
function getSystemPlatform() {
	return g_system_platform;
}

function setSystemPlatform(platform) {
	g_system_platform = platform;	
}

// 检测安装浏览器的平台
function checkSystemPlatform() {
	var ua = window.navigator.userAgent;
	var platform = "";

	if (ua.indexOf("HUAWEI") >= 0) {
		platform = HuaweiPlatform;	
	} else if (ua.indexOf("HM") >= 0) {
		platform = XiaomiPlatform;
	} else if (ua.indexOf("lpv") >=0) {
		platform = NexusPlatform;
	} else {
		platform = UnknownPlatform;
	}
	
	setSystemPlatform(platform);	
}

checkSystemPlatform();

var g_download_page = "download.html";
function getDownloadPage() {
	return g_download_page;	
}

// PUBLICAPI
// 使用本JS库的网页开发者，需要在导入这个库之后首先调用这个
// 函数进行一个全局设置，设置一个默认的游戏引擎下载提示页。
function setDownloadPage(url) {
	g_download_page = url;	
}

// 跳转到游戏下载页
function redirectToDownloadPage() {
	window.location.href = getDownloadPage();
}

// 启动app所需要的最长的时间，事实上用不了这么长的时间。
// 1000表示1000ms，也可以根据实际情况调整，比如700ms左右。
var g_launch_time = 1000;
function getLaunchTime() {
	return 	g_launch_time;
}

// 1. 对于系统浏览器，还需要具体区分一下。除了UC浏览器之外，其他的
// 浏览器在启动了游戏引擎之后会挂起当前浏览器中JS的执行；而UC浏览器
// 则会继续执行JS
// 2. 因此，这里有两个条件，只有当浏览器处于后台且没有超时的情况下
// 才会认为系统中没有安装游戏引擎，因此需要跳转到游戏引擎下载页
// 3. 对于UC浏览器而言，document.webkitHidden是判断游戏引擎是否存在的
// 条件；对于其他系统浏览器而言，有没有超时是判断游戏引擎是否存在的条件。
function downloadForSysBrowser(st) {
	var now = Date.now();
	var launchTime = getLaunchTime();
	if ( !document.webkitHidden && (now - st < launchTime + 200)) {
		redirectToDownloadPage();
	}
}

var g_delta_time = 5;	// 一个较小的timeout类型的定时器时间
function getDeltaTime() {
	return g_delta_time;
}

var g_callback_counter = 0;	// 定时器回调次数计数器
function getCallbackCounter() {
	return 	g_callback_counter;
}

function resetCallbackCounter() {
	g_callback_counter = 0;
}

function increaseCallbackCounter() {
	g_callback_counter++;	
}

// 回调函数可以回调的最大次数
var g_callback_total_counter = g_launch_time/g_delta_time;
function getCallbackTotalCounter() {
	return g_callback_total_counter;
}

// 1. 因为Chrome浏览器需要使用intent协议的url启动安卓的app
// 所以，默认情况下如果系统中不存在相应的app，那么Chrome
// 浏览器将会直接打开这个intent协议的url，显示网页无法打开。
// 2. 为了解决这个问题，就需要做特殊的处理，使得Chrome浏览器
// 既可以在app存在的情况下使用intent协议打开app又可以在app
// 不存在的情况下跳转到下载提示页。
// 3. 本方法的逻辑是，利用Chrome浏览器在app不存在的情况打开
// intent协议的url需要30ms左右的特定，设定一个较小的timeout
// 类型定时器，比如5ms，并且在定时器的回调函数中进行一定处理
// 从而使得Chrome在app存在的情况下能够启动app；在app不存在的
// 情况能够识别出来并跳转到下载提示页。
function downloadForChromeBrowser(st) {
	var callbackCounter = getCallbackCounter();
	// 1. 对于不同的手机平台，这个值是不一样的。对于Nexus 5而言，
	// 这里取值50比较合适；对于华为P6而言，取值22比较合适；对于
	// 红米手机而言，则不需要这个条件。因此，对于不同的平台这里需要
	// 进行不同的处理。
	// 2. 因此，对于Chrome而言，还需要了解当前Chrome所在平台的信息，
	// 比如，手机的型号等。从而能够提供不同的数值。对于华为平台取值为22；
	// 对于Nexus平台取值为50；其他平台暂不处理。具体的值还需要根据实际情况
	// 进一步优化。
	var locationResetCounter = getCallbackTotalCounter();
	// 获取当前的系统平台，如果是华为手机，比如华为P6，那么需要设置
	// 22；如果是Nexus手机，需要设置为50；其他手机暂时不需要任何特殊
	// 处理，比如小米手机中的红米手机。
	var systemPlatform = getSystemPlatform();
	if (systemPlatform == HuaweiPlatform) {
		locationResetCounter = 22;
	} else if (systemPlatform == NexusPlatform) {
		locationResetCounter = 50;
	} else {
	}
	 
	if (callbackCounter < locationResetCounter) {
		window.location.href = window.location.href;
	}
	
	if (!document.webkitHidden) {
		var now = Date.now();
		var deltaTime = getDeltaTime();
		var callbackTotalCounter = getCallbackTotalCounter();
		if (callbackCounter < callbackTotalCounter) {			
			setTimeout(function(){downloadForChromeBrowser(now)}, deltaTime);	
		} else if (now - st < deltaTime + 20) {
			redirectToDownloadPage();
		}
		
		increaseCallbackCounter();
	} else {
		resetCallbackCounter();	
	}
	
}

// 设定一个定时器，用来检测系统中是否已经安装了游戏引擎，
// 如果没有安装游戏引擎，则会自动跳转到游戏引擎下载提示界面
function install() {
	var browserType = getBrowserType();
	var st = Date.now();
	if ( browserType == SysBrowser) {
		var launchTime = getLaunchTime();
		setTimeout(function(){downloadForSysBrowser(st)}, launchTime);
	} else if (browserType == ChromeBrowser) {
		var deltaTime = getDeltaTime();
		setTimeout(function(){downloadForChromeBrowser(st)}, deltaTime);
	} else {
		alert("该浏览器尚未被支持，请使用傲游浏览器！");
	}
}

var g_mge_url = "";
function getMgeUrl() {
	return 	g_mge_url;
}

// PUBLICAPI
function setMgeUrl(url) {
	g_mge_url = url;	
}

// 系统自带浏览器、傲游浏览器、QQ浏览器和UC浏览器使用这种方式打开游戏引擎
function openAppForSysBrowser() {
	var ifr = document.createElement('iframe');
	ifr.src = getMgeUrl();
	ifr.style.display = "none";
	ifr.style.width = "100px";
	ifr.style.height = "100px";
	document.body.appendChild(ifr);
	document.body.removeChild(ifr);
}

// Chrome浏览器使用这种方式打开游戏引擎
function openAppForChromeBrowser() {
	window.location.href = getMgeUrl();
}		

// 根据不同的浏览器类型使用相应的方法尝试打开游戏引擎。
function openApp() {
	var browserType = getBrowserType();
	
	if ( browserType == SysBrowser) {
		openAppForSysBrowser();
	} else if (browserType == ChromeBrowser) {
		openAppForChromeBrowser();	
	} else {
		alert("该浏览器尚未被支持，请使用傲游浏览器！");
	}
}

// PUBLICAPI. EXAMPLE. 处理click事件的函数
// 使用本JS库的网页开发者，可以参考下面这个例子
// 这个例子中没有使用setDownloadPage函数，而是
// 使用的默认的游戏引擎下载提示页
function mgeFunc(e, needCheck, gameUrl) {
	// 阻止A标签的默认行为
	e.preventDefault();
	e.stopPropagation();
	
	// 获取目标节点上的相应参数信息
	// 支持三种获取方式，一种是从目标节点的父节点获取
	// 一般是A标签节点；一种是从目标节点获取。也就是
	// 如果目标节点的父节点不存在mgeurl，则获取目标
	// 节点的mgeurl，还一种是传入参数
	// 如果三种方式都不能获取url则提示失败
	var parentNode = e.target.parentNode;
	var mgeUrl = parentNode.getAttribute("mgeurl");
	if (!mgeUrl) {
		var target = e.target;
		mgeUrl = target.getAttribute("mgeurl");
	} 
	if (!mgeUrl) {
		mgeUrl = gameUrl;	
	}
	if (mgeUrl) {
		setMgeUrl(mgeUrl);
		
		// 只有当明确指出需要检测游戏引擎是否存在时，
		// 才尝试判断游戏引擎是否存在;
		if (needCheck) {
			install();
		}
			
		// 尝试打开游戏引擎
		openApp();
	} else {
		alert("mgeUrl不能为空");	
	}
}


